/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __maya_MayaDraw_h__
#define __maya_MayaDraw_h__

namespace fe
{

/**************************************************************************//**
    @brief Draw to Maya

	@ingroup maya
*//***************************************************************************/
class FE_DL_EXPORT MayaDraw: public DrawCommon
{
	public:
					MayaDraw(void):
						m_pFnMesh(NULL)										{}
virtual				~MayaDraw(void)
					{
						if(m_pFnMesh)
						{
							delete m_pFnMesh;
						}
					}

					//* as DrawI
virtual void		drawPoints(const SpatialVector *vertex,
							const SpatialVector *normal,U32 vertices,
							BWORD multicolor,const Color *color);

virtual	void		drawLines(const SpatialVector *vertex,
							const SpatialVector *normal,U32 vertices,
							StripMode strip,BWORD multicolor,
							const Color *color);

					//* Maya specific
		void		setMeshObject(const MObject a_meshObject)
					{
						m_meshObject=a_meshObject;
						if(m_pFnMesh)
						{
							delete m_pFnMesh;
						}
						m_pFnMesh=new MFnMesh(a_meshObject);
					}
const	MObject		meshObject(void)
					{	return m_meshObject; }

	private:
		MObject		m_meshObject;
		MFnMesh*	m_pFnMesh;
};

} // namespace

#endif /* __maya_MayaDraw_h__ */
