/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __core_Variant_h__
#define __core_Variant_h__

#define	FE_ISTYPE(T,V)	(V.typeID()==typeid(T))

namespace fe
{

/**************************************************************************//**
*//***************************************************************************/
class Variant: protected boost::any
{
	public:
						//* empty
						Variant(void)										{}

						//* set as 0 to store NULL pointer
						Variant(int value): boost::any(value)				{}

						template<typename T>
						Variant(const T& pointer)
//						{	boost::any::operator=<T>(pointer); }
						{	((boost::any&)*this)=pointer; }

						Variant(const Variant& variant) : boost::any()
//						:boost::any(variant)	{}
						{	((boost::any&)*this)=(const boost::any&)variant; }


						template<typename T>
		Variant			&operator=(const T& pointer)
//						{	boost::any::operator=<T>(pointer);
						{	((boost::any&)*this)=pointer;
							return *this; }

		Variant			&operator=(const Variant& variant)
//						{	boost::any::operator=((const boost::any&)variant);
						{
							((boost::any&)*this)=(const boost::any&)variant;
							return *this; }

						template<typename T>
						T castTo(void)
						{
							T pointer=NULL;
							try
							{
								pointer=boost::any_cast<T>(*this);
							}
							catch(const boost::bad_any_cast&)
							{
							}

							return pointer;
						}

const	std::type_info	&typeID(void) const		{	return any::type(); }

		BWORD			isEmpty(void) const		{	return any::empty(); }

		BWORD			isNull(void) const
						{
/*
							feLog("%p %p %p %p %p\n",&any::type(),
									&typeid(NULL),
									&typeid(U32),
									&typeid(int),
									&typeid(UWORD));
							feLog("%s %s %s %s %s\n",any::type().name(),
									typeid(NULL).name(),
									typeid(U32).name(),
									typeid(int).name(),
									typeid(UWORD).name());
*/
							return any::type()==typeid(int(NULL));
						}
};

} // namespace

#endif // __core_Variant_h__
